#define VOID

/* fastfile.c */

/* fidomain.c */

void set_hw(VOID); 
void reset_hw(VOID); 
void fido_settings(VOID); 
void rept_stack(VOID); 

/* nodestuff.c */

int open_node(VOID); 
int close_node(VOID); 
int node_files(VOID); 
int open_nmap(int);
int get_node(int);
int find_poll(unsigned);
int put_node(int);
int ntc_file(VOID); 
int get_ntc(int);
int put_ntc(int);
int find_ntc(struct _node *);
int index_node(struct _node *);
int find_node(struct _node *);
void set_nn(char *,struct _node *);
int next_node(unsigned);
int have_node(VOID); 
void make_trav(unsigned);
int find_ndat(struct _node *);
int get_ndat(int);
void fix_node(struct _node *);
int is_nethost(struct _node *);
int is_reghost(struct _node *);
int is_host(struct _node *);
int is_zonehost(struct _node *);
int is_point(struct _node *);
int same_zone(struct _node *,struct _node *);
int same_net(struct _node *,struct _node *);
int same_node(struct _node *,struct _node *);
int same_point(struct _node *,struct _node *);
void cpy_node(struct _node *,struct _node *);
char *str_node(struct _node *);
int is_us(struct _node *);
void makenname(char *,char *);

/* support.c */

int lidiv(long,int);
char *string(unsigned);
int shared(VOID); 
void stoggle(int,int);
int istoggle(int);
int fbit(int);
int append(char *);
void open_log(char *);
void close_log(VOID); 
void close_up(VOID); 
void logoff(int,int);
void maketid(char *,char *);
int opentf(char *,int);
void maketname(char *,char *);
void makefname(char *,char *);
void makesname(char *,char *);
void makeuname(char *,char *);
void makemname(char *,char *);
void makexname(char *,char *,char *);
int getmarea(unsigned);
int getfarea(unsigned);
int getarea(unsigned,struct _area *,int);
int getsys(VOID); 
int putsys(VOID); 
char *bucks_str(unsigned);
int nearestn(long,long);
int fcomp(char *,char *,int);

/* tlg.c */

void timelog(int);

/* printf.c */

/*
void printf(char *);
void cprintf(char *);
void mprintf(char *);
void lprintf(char *);
void clprintf(char *);
void puts(char *);
void cputs(char *);
void mputs(char *);
void clputs(char *);
void lputs(char *);
void sprintf(char *,char *);
void _fspr(char *,char **);
*/

/* bufio.c */

void idle(VOID); 
void limitchk(VOID); 
void mbreak(VOID); 
int modstat(VOID); 
void modout(char);
int modin(unsigned);
void mflush(VOID); 
void delay(int);
void carrierchk(VOID); 
int cd(VOID); 
void flush(int);

/* badname.c */

void xferstat(int,long,char *);
char *strip_path(VOID);
int badname(char *);
int fexist(char *);
int chkabort(VOID); 
int baudrate(VOID); 

/* sched.c */

int til_sched(char,int,int);
void dsp_event(char *,int);
void markevt(unsigned);
void clrevts(VOID); 
void clrrevts(VOID); 
void clrcevts(VOID); 
void clrevt(unsigned);
int cont(unsigned);
int rush(unsigned);
void set_cont(int);
void set_rush(int);
int til_event(int);

/* msgsprt.c */

void killmsg(int);
int *msg_highest(VOID); 
int *msg_total(VOID); 
int msgcount(VOID); 
void msgzap(VOID); 
void wrtmsg(VOID); 
void closemsg(VOID); 
int findmsg(int,int);

/* mdmfunc.c */

int modem_init(int);
void modem_type(VOID); 
int setbaud(unsigned);
void discon(VOID); 
int dial(char *);
int answer(VOID); 

/* abort.c */

/* dbldos.c */

/* desqview.c */

/* zmodem.c */
far zsend();
far zrecv();

/* xmodem.c */
far xrecv();
far xsend();

int ksend(char *,char *,unsigned);
int krecv(char *,char *,unsigned);

/* spack.c.c */

/* fidoini.c */

void fidoini(int,char **);

/* fido.c */

void fido_ov_load(VOID); 
int do_fido(VOID); 
int openclr(VOID); 
void close_clr(VOID); 
int write_clr(VOID); 

/* mainmenu.c */

void main_menu(VOID); 

/* msgmenu.c */

void msg_menu(VOID); 

/* filemenu.c */

void file_menu(VOID); 
void dos_date(struct _xfbuf *);
void dos_time(struct _xfbuf *);

/* files.c */

void ffind(VOID); 
void chdir(VOID); 
void fdelete(VOID); 
int kfile(char *,char *);
int file_disp(char *);
void download(VOID); 
void upload(VOID); 
void ftype(VOID); 
void xfer_time(char *,unsigned *,unsigned *);

/* bulletins.c */

void bulletin(VOID); 

/* maincmds.c */

void change(VOID); 
void callers(VOID); 
void switches(VOID); 

/* msend.c */

int editmsg(int);
int msend(int,int);

/* usupport.c */

void dsparea(int,struct _area *,char);
void stats(int);
void setovpath(VOID); 
int extlogin(char *);
int uval(int,int);
void setuval(int,int,int);
int strsum(char *);
int dispbbs(char *);
void dumptext(int);
void goodbye(char *);
int wordlen(char *,int);

/* chat.c */

void chat(VOID); 

/* signon.c */

int signon(VOID); 

/* question.c */

int question(char *,char *);

/* descfile.c */

void descfile(char *);

/* mainstuf.c */

void mail_pending(VOID); 
void execute(char *);

/* quote.c */

void quote(char *);

/* edit.c */

int edit(int,int,int,char *);
int del_line(int,int,char *);
int ins_line(int,int,char *);
int substr(char *,char *,char *,int);

/* listnode.c */

int list_nodes(struct _node *,int);
void listnode(struct _ndat *);

/* getfield.c */

void mcrlf(VOID); 
char *getarg();		/* string ID or 0,string */
int isargs(VOID); 
void cmdflush(VOID); 
int getfield(char *,char *,int,int,int,int);
void strproc(char *,char *,int);
int yverf();
int nverf();
int askyn();
int getstring(char *);
void mconout(char);
void mconoutr(char);
void mconflush(VOID);
void more(VOID); 
int mconin(VOID); 
int mconstat(VOID); 
void pollkbd(VOID); 

/* prompt.c */

int help(char *,struct _cmd *,char *);
int dumphelp(char,int);
int prompt(struct _cmd *,unsigned,char *,int);
int sprompt(struct _cmd *,unsigned,int);
int is_cmd(char,struct _cmd *);
int allowedx(long,char);
int allowed(struct _area *);
int unlocked(long);
void highlight(VOID); 
void unhighlight(VOID); 

/* lastuser.c */

void read_lastuser(VOID); 
void write_lastuser(VOID); 

/* language.c */

int loadlang(int);
void picklang(VOID); 

/* fidonet.c */

int do_fidonet(unsigned);
void inmail(int);
void net_new(VOID); 
int evtabort(VOID); 

/* router.c */

void open_route(char,int);
int out_xlate(VOID); 

/* mail.c */

void recv_mail(char);
void send_mail(int);
void pktcompl(int);

/* packet.c */

void re_packet(VOID); 
int make_packets(VOID); 

/* unpacket.c */

int unpacket(char *);

/* markmsg.c */

void clearmsg(VOID); 
void markmsg(struct _node *);

/* markusr.c */

void markusr(VOID); 
